{{- if .Values.frontend.frontend_client.enabled -}}
apiVersion: apps/v1
kind: Deployment
metadata:
  name: {{ include "fullname" (list . .Values.frontend.frontend_client.name) }}
  labels:
    {{- include "common.labels" (list . .Values.frontend.frontend_client.name) | nindent 4 }}
spec:
  replicas: {{ .Values.frontend.frontend_client.replicaCount }}
  strategy:
    {{- .Values.frontend.frontend_client.strategy | default .Values.global.strategy | toYaml | nindent 4 }}
  selector:
    matchLabels:
      app.kubernetes.io/name: {{ .Values.frontend.frontend_client.name }}
  template:
    metadata:
      {{- with .Values.global.podAnnotations }}
      annotations:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      labels:
        {{- include "selectorLabels" (list . .Values.frontend.frontend_client.name) | nindent 8 }}
    spec:
      {{- with .Values.global.imagePullSecrets }}
      imagePullSecrets:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      serviceAccountName: {{ include "serviceAccountName" (list . .Values.frontend.frontend_client.name) }}
      securityContext:
        {{- include "zaaksysteem.default_pod_security_context" . | nindent 8 }}

      containers:
        - name: {{ .Values.frontend.frontend_client.name }}
          securityContext:
            {{- include "zaaksysteem.default_security_context" . | nindent 12 }}

          image: "{{ .Values.frontend.frontend_client.image.repository }}:{{ .Values.frontend.frontend_client.image.tag | default .Chart.AppVersion }}"
          imagePullPolicy: {{ .Values.global.image.pullPolicy }}
          command: ["nginx"]
          args: ["-g", "daemon off;"]
          ports:
            - containerPort: 8080
              name: http
              protocol: TCP
          env:
          {{- range $key, $value := $.Values.extraEnv }}
          - name: {{ $key }}
            value: "{{ $value }}"
          {{- end }}
          resources:
            {{- toYaml .Values.frontend.frontend_client.resources | nindent 12 }}
          volumeMounts:
            - name: nginx-conf
              mountPath: /etc/nginx/nginx.conf
              subPath: nginx.conf
            - mountPath: /var/cache/nginx
              name: nginx-cache-volume
            - mountPath: /var/run
              name: nginx-run-volume
      volumes:
        - name: nginx-conf
          configMap:
            name: {{ include "fullname" (list . .Values.frontend.frontend_client.name) }}-nginx-conf-configmap
        - name: nginx-cache-volume
          emptyDir:
            sizeLimit: 100Mi
        - name: nginx-run-volume
          emptyDir:
            sizeLimit: 10Mi
      {{- with .Values.frontend.frontend_client.nodeSelector }}
      nodeSelector:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      affinity:
        {{- include "zaaksysteem.affinity" (dict "name" .Values.frontend.frontend_client.name "Release" $.Release) | nindent 8 }}

      {{- with .Values.frontend.frontend_client.tolerations }}
      tolerations:
        {{- toYaml . | nindent 8 }}
      {{- end }}
{{- end }}